<?php

/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0]) || isset($_SERVER['REQUEST_METHOD'])  || isset($_SERVER['REMOTE_ADDR'])) {
	die("<br><strong>This script is only meant to run at the command line.</strong>");
}

$no_http_headers = true;

/* display No errors */
error_reporting(0);

if (isset($config)) {
	include_once(dirname(__FILE__) . "/../lib/snmp.php");
}

if (!isset($called_by_script_server)) {
	include_once(dirname(__FILE__) . "/../include/global.php");
	include_once(dirname(__FILE__) . "/../lib/snmp.php");

	array_shift($_SERVER["argv"]);

	print call_user_func_array("execscripts", $_SERVER["argv"]);
}

//  : 
// <method>:<hostname>:<snmp_port>:<snmp_version>:<snmp_timeout>:<snmp_community>:<snmp_username>:<snmp_password>:<snmp_auth_protocol>:<snmp_priv_passphrase>:<snmp_priv_protocol>
function execscripts($snmp) {
	$snmp 		= explode(":", $snmp);
	$method 		= $snmp[0];
	$hostname 	= $snmp[1];
	$snmp_port 	= $snmp[2];
	$snmp_version = $snmp[3];
	$snmp_timeout = $snmp[4];
	
	$snmp_auth_username   	= "";
	$snmp_auth_password   	= "";
	$snmp_auth_protocol  	= "";
	$snmp_priv_passphrase 	= "";
	$snmp_priv_protocol   	= "";
	$snmp_context         	= "";
	$snmp_community 	= "";
	
	$ping_retries 	= 5;
	$max_oids 	= 50;

	if ($snmp_version == 3) {
		$snmp_auth_username 	= $snmp[6];
		$snmp_auth_password 	= $snmp[7];
		$snmp_auth_protocol 	= $snmp[8];
		$snmp_priv_passphrase 	= $snmp[9];
		$snmp_priv_protocol 	= $snmp[10];
	}else{
		$snmp_community = $snmp[5];
	}

	$retval = 'U';
	// Full OID:   .1.3.6.1.4.1.2021.8.1
	$oids = array(
		"names" => ".1.3.6.1.4.1.2021.8.1.2",     # .1.3.6.1.4.1.2021.8.1.extNames
		"output" => ".1.3.6.1.4.1.2021.8.1.101",  # .1.3.6.1.4.1.2021.8.1.extOutput
		);
		
	$rep=0;
	while (true) {
		$arr_names = cacti_snmp_walk($hostname, $snmp_community, $oids['names'], $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, SNMP_POLLER);
		for ($i=0;($i<sizeof($arr_names));$i++) {
			if  ($arr_names[$i]['value'] == $method) {
				/* cacti_snmp_walk   ,     2 : ['oid']  ['value'] */
				$arr_list = cacti_snmp_walk($hostname, $snmp_community, $oids['output'], $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, SNMP_POLLER);
				if ( ($arr_list) && ($arr_list[$i]) && ($arr_list[$i]['value']) ) {
					$retval = $arr_list[$i]['value'];
					break;
				}else{
					sleep(1);
				}  
			}
		}
		if ( ($retval!='U') || ( ($retval=='U') && (++$rep>5) ) ) break;
		sleep(1);
	}
	return $retval;
}

?>
